#!/bin/sh

# Enable font-size, tabbedex and matcher extensions.
awk -v DATE="$(date -Ins)" '
# Append new extensions to existing resource.
/^URxvt.perl-ext-common:/ {
  na = split($0, a, /[: \t]+/)
  resource = a[1]
  # explode value
  ne = split(a[na], e, /,/)
  for(i = 1; i <= ne; i++) seen[e[i]] = 1;
  # add new extensions
  if(!seen[x = "font-size"]) e[++ne] = x;
  if(!seen[x = "tabbedex"])  e[++ne] = "-tabbed,"x;
  if(!seen[x = "matcher"])   e[++ne] = x;
  # implode new value
  extensions = e[1]
  for(i = 2; i <= ne; i++) extensions = extensions","e[i]
  extensions = resource": "extensions
}
$0 ~ "Begin by package rxvt-unicode_perl-9.22_2019.09.17_dda8c82-x86_64-191123" {
  ALREADY_DONE=1
}

END {
  # Do not repeat myself.
  if(ALREADY_DONE) exit(0)
  # Assign new extensions to non-existent resource.
  if("" == extensions) {
    extensions = "URxvt.perl-ext-common: default,font-size,-tabbed,tabbedex,matcher"
  }
  section ="\n"\
"!Begin by package rxvt-unicode_perl-9.22_2019.09.17_dda8c82-x86_64-191123 {{{\n"\
"! Automatically added on "DATE"\n"\
"! Locations of perl extensions: /usr/local/lib64/urxvt/perl  ~/.urxvt/ext\n"\
"! Key mappings: Use   xev -event keyboard   to identify key names (letter case matters!)\n"\
"! Note: URxvt ISO 14755 mode preempts keysym modifier combination Shift+Control.\n"\
"!\n"\
"! Font Size extension: Font size changes apply to new windows not to new tabs; :reset applies to the current tab.\n"\
"URxvt.keysym.C-Up:    font-size:increase\n"\
"URxvt.keysym.C-Down:  font-size:decrease\n"\
"URxvt.keysym.C-Prior: font-size:incglobal\n"\
"URxvt.keysym.C-Next:  font-size:decglobal\n"\
"URxvt.keysym.C-equal: font-size:reset\n"\
"URxvt.keysym.C-slash: font-size:show\n"\
"!\n"\
"! Tabbedex extension. Default key bindings S-{Down/Up/Left/Right}, C-{Left,Right}, M-{F1..F12}\n"\
"URxvt.tabbed.tabbedex-rs-prefix: tabbedex\n"\
"!\n"\
"! Matcher extension: mouse middle button\n"\
"URxvt.matcher.button:   2\n"\
"URxvt.matcher.launcher: defaultbrowser\n"\
"! Enter url selection mode. Default key sub-bindings {Up/Down/Home/End/Escape/Enter/y(ank)}\n"\
"URxvt.keysym.M-C-u:     matcher:select\n"\
"!\n"\
"! Sort out conflicting key bindings between default extensions searchable-scrollback and keyboard-select\n"\
"! keyboard-select:\n"\
"URxvt.keysym.M-Escape: perl:keyboard-select:activate\n"\
"! XXX: resource marked as deprecated, but is required to remove the default keysym!\n"\
"URxvt.searchable-scrollback: C-M-r\n"\
"! Should be:\n"\
"URxvt.keysym.M-s: builtin:\n"\
"URxvt.keysym.C-M-r: searchable-scrollback:start\n"\
"URxvt.keysym.C-M-s: perl:keyboard-select:search\n"\
"!\n"\
extensions"\n"\
"!\n"\
"! 24-bit true color emulation is supported for both 88-color and 256-color palette builds.\n"\
"! See https://gist.github.com/XVilka/8346728.\n"\
"! In turn terminal vim needs termguicolors set, cf. he: xterm-true-color. Add to ~/.vim/vimrc:\n"\
"! if strlen($COLORTERM) | set termguicolors | end\n"\
"!\n"\
"! After urxvt release 9.22 you must load the perl `background` extension for resource backgroundPixmap (-pixmap) to work:\n"\
"!URxvt.perl-ext: background\n"\
"!\n"\
"!End rxvt-unicode_perl-9.22_2019.09.17_dda8c82-x86_64-191123 }}}"
  print section >> FILENAME
  print section
}' "$HOME/.Xresources" | DISPLAY=${DISPLAY:-:0} xrdb -merge -quiet
